#!/bin/bash
SVC="$1"

[ -d "../$SVC" ] || { echo "USAGE: $0 svcname"; exit 1; }

echo "launching $SVC in debug mode"

docker-compose -f docker-compose.yml -f <(cat <<EOF
version: '3.5'
services:
  mashroom-$SVC:
    build:
      context: ../common/docker/godebug
      dockerfile: Dockerfile
    image: "registry.gitlab.mashplace.com/mashplace/devops/infrastructure/godebug:1.15.6"
    working_dir: "/go/src/gitlab.mashplace.com/mashplace/backend/$SVC"
    command: "/dlv debug --headless --listen=:2345 --api-version=2 --continue --accept-multiclient --log ./cmd/mashroom-$SVC"
    volumes:
      - 'mashroom-backend-volume:/go/src/gitlab.mashplace.com/mashroom'
      - 'mashroom-gopath-volume:/go'

volumes:
  mashroom-backend-volume:
    driver: local
    driver_opts:
      type: none
      o: bind
      device: "$(cd ${PWD}/../..; pwd)"  
  mashroom-gopath-volume:
    driver: local
    driver_opts:
      type: none
      o: bind
      device: "${GOPATH}"
EOF
) up -d mashroom-$SVC
