package connections

import (
	address "gitlab.mashplace.com/mashplace/backend/address/api"
	auth "gitlab.mashplace.com/mashplace/backend/auth/api"
	cardpayment "gitlab.mashplace.com/mashplace/backend/cardpayment/api"
	closecom "gitlab.mashplace.com/mashplace/backend/closecom/api"
	comments "gitlab.mashplace.com/mashplace/backend/comments/api"
	"gitlab.mashplace.com/mashplace/backend/common/generic/env"
	"gitlab.mashplace.com/mashplace/backend/common/generic/grpc"
	contract "gitlab.mashplace.com/mashplace/backend/contract/api"
	expenses "gitlab.mashplace.com/mashplace/backend/expenses/api"
	extras "gitlab.mashplace.com/mashplace/backend/extras/api"
	geo "gitlab.mashplace.com/mashplace/backend/geo/api"
	grabdata "gitlab.mashplace.com/mashplace/backend/grabdata/api"
	identity "gitlab.mashplace.com/mashplace/backend/identity/api"
	insurance "gitlab.mashplace.com/mashplace/backend/insurance/api"
	invitation "gitlab.mashplace.com/mashplace/backend/invitation/api"
	invoice "gitlab.mashplace.com/mashplace/backend/invoice/api"
	listing "gitlab.mashplace.com/mashplace/backend/listing/api"
	maintenance "gitlab.mashplace.com/mashplace/backend/maintenance/api"
	messaging "gitlab.mashplace.com/mashplace/backend/messaging/api"
	mixpanel "gitlab.mashplace.com/mashplace/backend/mixpanel/api"
	mortgage "gitlab.mashplace.com/mashplace/backend/mortgage/api"
	notes "gitlab.mashplace.com/mashplace/backend/notes/api"
	notification "gitlab.mashplace.com/mashplace/backend/notification/api"
	oauth "gitlab.mashplace.com/mashplace/backend/oauth/api"
	plaid "gitlab.mashplace.com/mashplace/backend/plaid/api"
	rightmove "gitlab.mashplace.com/mashplace/backend/rightmove/api"
	signature "gitlab.mashplace.com/mashplace/backend/signature/api"
	stats "gitlab.mashplace.com/mashplace/backend/stats/api"
	tenancy "gitlab.mashplace.com/mashplace/backend/tenancy/api"
	tokenio "gitlab.mashplace.com/mashplace/backend/tokenio/api"
	twilio "gitlab.mashplace.com/mashplace/backend/twilio/api"
	viewing "gitlab.mashplace.com/mashplace/backend/viewing/api"
	zoopla "gitlab.mashplace.com/mashplace/backend/zoopla/api"
)

var SiteURL = env.ResolveString("SITE_URL", "dev.env.mashroom.com")

var AuthServiceURL = env.ResolveString("AUTH_SERVICE_URL", "mashroom-auth:10000")
var AuthService = auth.NewAuthServiceClient(grpc.Dial(AuthServiceURL, "Auth"))

var ContractServiceURL = env.ResolveString("CONTRACT_SERVICE_URL", "mashroom-contract:10000")
var ContractService = contract.NewContractServiceClient(grpc.Dial(ContractServiceURL, "Contract"))

var ClosecomServiceURL = env.ResolveString("CLOSECOM_URL", "mashroom-closecom:10000")
var ClosecomService = closecom.NewClosecomServiceClient(grpc.Dial(ClosecomServiceURL, "Closecom"))

var InvitationServiceURL = env.ResolveString("INVITATION_SERVICE_URL", "mashroom-invitation:10000")
var InvitationService = invitation.NewInvitationServiceClient(grpc.Dial(InvitationServiceURL, "Invitation"))

var MessagingServiceURL = env.ResolveString("MESSAGING_SERVICE_URL", "mashroom-messaging:10000")
var MessagingService = messaging.NewMessagingServiceClient(grpc.Dial(MessagingServiceURL, "Messaging"))

var TenancyServiceURL = env.ResolveString("TENANCY_SERVICE_URL", "mashroom-tenancy:10000")
var TenancyService = tenancy.NewTenancyServiceClient(grpc.Dial(TenancyServiceURL, "Tenancy"))

var ViewingServiceURL = env.ResolveString("VIEWING_SERVICE_URL", "mashroom-viewing:10000")
var ViewingService = viewing.NewViewingServiceClient(grpc.Dial(ViewingServiceURL, "Viewing"))

var AddressServiceURL = env.ResolveString("ADDRESS_SERVICE_URL", "mashroom-address:10000")
var AddressService = address.NewAddressServiceClient(grpc.Dial(AddressServiceURL, "Address"))

var GeoServiceURL = env.ResolveString("GEO_SERVICE_URL", "mashroom-geo:10000")
var GeoService = geo.NewGeoServiceClient(grpc.Dial(GeoServiceURL, "Geo"))

var SignatureServiceURL = env.ResolveString("SIGNATURE_SERVICE_URL", "mashroom-signature:10000")
var SignatureService = signature.NewSignatureServiceClient(grpc.Dial(SignatureServiceURL, "Signature"))

var OauthServiceURL = env.ResolveString("OAUTH_SERVICE_URL", "mashroom-oauth:10000")
var OauthService = oauth.NewOAuthServiceClient(grpc.Dial(OauthServiceURL, "Oauth"))

var ExtrasServiceURL = env.ResolveString("EXTRAS_SERVICE_URL", "mashroom-extras:10000")
var ExtrasService = extras.NewExtrasServiceClient(grpc.Dial(ExtrasServiceURL, "Extras"))

var CardPaymentServiceURL = env.ResolveString("CARDPAYMENT_SERVICE_URL", "mashroom-cardpayment:10000")
var CardPaymentService = cardpayment.NewCardpaymentServiceClient(grpc.Dial(CardPaymentServiceURL, "Cardpayment"))

var InvoiceServiceURL = env.ResolveString("INVOICE_SERVICE_URL", "mashroom-invoice:10000")
var InvoiceService = invoice.NewInvoiceServiceClient(grpc.Dial(InvoiceServiceURL, "Invoice"))

var RightmoveServiceURL = env.ResolveString("RIGHTMOVE_SERVICE_URL", "mashroom-rightmove:10000")
var RightmoveService = rightmove.NewRightmoveServiceClient(grpc.Dial(RightmoveServiceURL, "Rightmove"))

var ZooplaServiceURL = env.ResolveString("ZOOPLA_SERVICE_URL", "mashroom-zoopla:10000")
var ZooplaService = zoopla.NewZooplaServiceClient(grpc.Dial(ZooplaServiceURL, "Zoopla"))

var MaintenanceServiceURL = env.ResolveString("MAINTENANCE_SERVICE_URL", "mashroom-maintenance:10000")
var MaintenanceService = maintenance.NewMaintenanceServiceClient(grpc.Dial(MaintenanceServiceURL, "Maintenance"))

var TwilioServiceURL = env.ResolveString("TWILIO_SERVICE_URL", "mashroom-twilio:10000")
var TwilioService = twilio.NewTwilioServiceClient(grpc.Dial(TwilioServiceURL, "Twilio"))

var NotesService = notes.NewNotesServiceClient(grpc.Dial(
	env.ResolveString("NOTES_SERVICE_URL", "mashroom-notes:10000"),
	"Notes",
))

var NotificationServiceURL = env.ResolveString("NOTIFICATION_SERVICE_URL", "mashroom-notification:10000")
var NotificationService = notification.NewNotificationServiceClient(grpc.Dial(NotificationServiceURL, "Notification"))

var TokenioServiceURL = env.ResolveString("TOKENIO_SERVICE_URL", "mashroom-tokenio:10000")
var TokenioService = tokenio.NewTokenioServiceClient(grpc.Dial(TokenioServiceURL, "Tokenio"))

var PlaidServiceURL = env.ResolveString("PLAID_SERVICE_URL", "mashroom-plaid:10000")
var PlaidService = plaid.NewPlaidServiceClient(grpc.Dial(PlaidServiceURL, "Plaid"))

var StatsServiceURL = env.ResolveString("STATS_SERVICE_URL", "mashroom-stats:10000")
var StatsService = stats.NewStatsServiceClient(grpc.Dial(StatsServiceURL, "Stats"))

var MortgageServiceURL = env.ResolveString("MORTGAGE_SERVICE_URL", "mashroom-mortgage:10000")
var MortgageService = mortgage.NewMortgageServiceClient(grpc.Dial(MortgageServiceURL, "Mortgage"))

var InsuranceServiceURL = env.ResolveString("INSURANCE_SERVICE_URL", "mashroom-insurance:10000")
var InsuranceService = insurance.NewInsuranceServiceClient(grpc.Dial(InsuranceServiceURL, "Insurance"))

var MixpanelService = mixpanel.NewMixpanelServiceClient(grpc.Dial(
	env.ResolveString("MIXPANEL_SERVICE_URL", "mashroom-mixpanel:10000"),
	"Mixpanel",
))

var GrabDataServiceURL = env.ResolveString("GRABDATA_SERVICE_URL", "mashroom-grabdata:10000")
var GrabDataService = grabdata.NewGrabDataServiceClient(grpc.Dial(GrabDataServiceURL, "Grabdata"))

var IdentityService = identity.NewIdentityServiceClient(grpc.Dial(
	env.ResolveString("IDENTITY_SERVICE_URL", "mashroom-identity:10000"),
	"Identity",
))

var ExpensesService = expenses.NewExpensesServiceClient(grpc.Dial(
	env.ResolveString("EXPENSES_SERVICE_URL", "mashroom-expenses:10000"),
	"Expenses",
))

var CommentsService = comments.NewCommentServiceClient(grpc.Dial(
	env.ResolveString("COMMENTS_SERVICE_URL", "mashroom-comments:10000"),
	"Comments",
))

var ListingService = listing.NewListingServiceClient(grpc.Dial(
	env.ResolveString("LISTING_SERVICE_URL", "mashroom-listing:10000"),
	"Listing",
))
