// Package gwctx provides gateway context utilities
package gwctx

import (
	"context"
	"reflect"

	"github.com/eientei/wsgraphql/mutcontext"
	"github.com/opentracing/opentracing-go"
)

var OperationContextKey = "opctx"

func OperationContext(ctx context.Context) mutcontext.MutableContext {
	v, ok := ctx.Value(OperationContextKey).(mutcontext.MutableContext)
	if !ok {
		return nil
	}

	return v
}

// ActiveSpanKey export
var ActiveSpanKey = reflect.ValueOf(struct{}{}).
	Convert(
		reflect.ValueOf(
			opentracing.ContextWithSpan(context.Background(), opentracing.GlobalTracer().StartSpan("")),
		).Elem().FieldByName("key").Elem().Type(),
	).Interface()
