package legacy

import (
	"strings"

	invitation "gitlab.mashplace.com/mashplace/backend/invitation/api"
)

func ConvertInvitationLegacy(m *invitation.Invitation) *invitation.InvitationInfo {
	parts := strings.SplitN(m.GetInvitee().GetName(), " ", 2)

	var firstname, lastname string

	firstname = parts[0]

	if len(parts) > 1 {
		lastname = parts[1]
	}

	return &invitation.InvitationInfo{
		Id:               m.GetId(),
		Type:             m.GetType(),
		InviterId:        m.GetHostId(),
		InviteeId:        m.GetInvitee().GetUserId(),
		InviteeEmail:     m.GetInvitee().GetEmail(),
		InviteePhone:     m.GetInvitee().GetPhone(),
		InviteeFirstName: firstname,
		InviteeLastName:  lastname,
		PropertyId:       m.GetProperty().GetPropertyId(),
		Body:             "",
		CreatedAt:        m.GetCreatedAt(),
		ExpiresAt:        m.GetExpiresAt(),
		Status:           m.GetStatus(),
		Offer:            m.GetOffer(),
		Message:          m.GetMessage(),
		UpdatedAt:        m.GetUpdatedAt(),
	}
}

func ConvertInvitationsLegacy(ms []*invitation.Invitation) (invs []*invitation.InvitationInfo) {
	for _, m := range ms {
		invs = append(invs, ConvertInvitationLegacy(m))
	}

	return
}
