package rest

import (
	"io"
	"net/http"

	plaid "gitlab.mashplace.com/mashplace/backend/plaid/api"

	"gitlab.mashplace.com/mashplace/backend/common/generic/log"
	"gitlab.mashplace.com/mashplace/backend/gateway/impl/connections"
)

func PlaidWebhookHandler(w http.ResponseWriter, r *http.Request) {
	body, err := io.ReadAll(r.Body)
	if len(body) == 0 {
		log.Errorf("PlaidWebhookHandler error reading request body: %v\n", err)
		onError(w, err)
		return
	}

	_, err = connections.PlaidService.WebhookHandler(r.Context(), &plaid.WebhookHandlerRequest{
		Verification: r.Header.Get("Plaid-Verification"),
		Data:         body,
	})
	if err != nil {
		onError(w, err)
		return
	}

	w.WriteHeader(http.StatusOK)
}
