package rest

import (
	"fmt"
	"net/http"

	"gitlab.mashplace.com/mashplace/backend/common/generic/log"
)

type AppHandler func(*http.Request) (int, string, error)

func (fn AppHandler) ServeHTTP(w http.ResponseWriter, r *http.Request) {
	if status, text, err := fn(r); err != nil {
		log.Error(err)
		http.Error(w, text, status)
	} else {
		_, _ = fmt.Fprint(w, text)
	}
}

func Err500Result(err error) (int, string, error) {
	return http.StatusInternalServerError, http.StatusText(http.StatusInternalServerError), err
}
