package rest

import (
	"fmt"
	"io"
	"net/http"

	account "gitlab.mashplace.com/mashplace/backend/account/api"

	"gitlab.mashplace.com/mashplace/backend/common/generic/log"
	"gitlab.mashplace.com/mashplace/backend/gateway/impl/connections"
)

func VeriffHandlerResult(w http.ResponseWriter, r *http.Request) {
	bs, err := io.ReadAll(r.Body)
	if err != nil {
		log.WithError(err).Error("reading veriff decision status request body")
		http.Error(w, err.Error(), http.StatusBadRequest)

		return
	}

	if bs == nil {
		log.WithError(err).Error("veriff decision status request body is empty")
		http.Error(w, err.Error(), http.StatusBadRequest)

		return
	}

	fmt.Println("WEBHOOK DATA: ", string(bs))

	_, err = connections.AccountService.DecisionWebhookResult(r.Context(),
		&account.DecisionWebhookStatusRequest{
			Data: bs,
		})
	if err != nil {
		log.WithError(err).Errorf("processing rentprofile status request body: %s", string(bs))
		http.Error(w, err.Error(), http.StatusInternalServerError)

		return
	}
}

func VeriffEventHandlerResult(w http.ResponseWriter, r *http.Request) {
	bs, err := io.ReadAll(r.Body)
	if err != nil {
		log.WithError(err).Error("reading veriff event status request body")
		http.Error(w, err.Error(), http.StatusBadRequest)

		return
	}

	if len(bs) == 0 {
		log.WithError(err).Error("veriff event status request body is empty")
		http.Error(w, err.Error(), http.StatusBadRequest)

		return
	}

	fmt.Println("WEBHOOK DATA: ", string(bs))

	_, err = connections.AccountService.EventWebhookResult(r.Context(),
		&account.EventWebhookStatusRequest{
			Data: bs,
		})
	if err != nil {
		log.WithError(err).Errorf("processing rentprofile status request body: %s", string(bs))
		http.Error(w, err.Error(), http.StatusInternalServerError)

		return
	}
}
