package schema

import (
	"github.com/graphql-go/graphql"
	"gitlab.mashplace.com/mashplace/backend/common/graphql/util"
	"gitlab.mashplace.com/mashplace/backend/gateway/impl/resolvers"
	"gitlab.mashplace.com/mashplace/backend/gateway/impl/resolvers/admin"
)

var RootQueries = make(graphql.Fields)

var RootMutations = make(graphql.Fields)

var RootSubscriptions = make(graphql.Fields)

func CompileSchema() (graphql.Schema, error) {
	resolvers.InitSchema(&RootQueries, &RootMutations, &RootSubscriptions)
	admin.InitSchema(&RootQueries, &RootMutations)
	return util.CompileSchema(RootQueries, RootMutations, RootSubscriptions)
}
